""" displacement energy """

# displacement, lattice, surface
default = [25.0, 3.0, 2.0]

disp = {
    'H':[10.0, 3.0, 2.0],
    'He':[5.0, 1.0, 2.0],
    'Li':[25, 3, 1.62],
    'Be':[25, 3, 3.38],
    'B':[25, 3, 5.73],
    'C':[28, 3, 7.41],
    'N':[28, 3, 2],
    'O':[28, 3, 2],
    'F':[25, 3, 2],
    'Ne':[5.0, 1.0, 2.0],
    'Na':[25, 3, 1.12],
    'Mg':[25, 3, 1.54],
    'Al':[25, 3, 3.36],
    'Si':[15, 2, 4.7], 
    'P':[25, 3, 3.27],
    'S':[25, 3, 2.88], 
    'Cl':[25, 3, 2],
    'Ar':[5.0, 1.0, 2.0],
    'K':[25, 3, 0.93], 
    'Ca':[25, 3, 1.83],
    'Sc':[25, 3, 3.49],
    'Ti':[25, 3, 4.89],
    'V':[25, 3, 5.33],
    'Cr':[25, 3, 4.12],
    'Mn':[25, 3, 2.98],
    'Fe':[25, 3, 4.34],
    'Co':[25, 3, 4.43],
    'Ni':[25, 3, 4.46],
    'Cu':[25, 3, 3.52],
    'Zn':[25, 3, 1.35],
    'Ga':[25, 3, 2.82],
    'Ge':[15, 2, 3.88],
    'As':[25, 3, 1.26],
    'Se':[25, 3, 2.14],
    'Br':[25, 3, 2],
    'Kr':[5, 1, 2],
    'Rb':[25, 3, 0.86], 
    'Sr':[25, 3, 1.7],
    'Y':[25, 3, 4.24],
    'Zr':[25, 3, 6.33],
    'Nb':[25, 3, 7.59],
    'Mo':[25, 3, 6.83],
    'Tc':[25, 3, 2],
    'Ru':[25, 3, 6.69],
    'Rh':[25, 3, 5.78],
    'Pd':[25, 3, 3.91],
    'Ag':[25, 3, 2.97],
    'Cd':[25, 3, 1.16],
    'In':[25, 3, 2.49],
    'Sn':[25, 3, 3.12],
    'Sb':[25, 3, 2.72],
    'Te':[25, 3, 2.02],
    'I':[25, 3, 2],
    'Xe':[5, 1, 2],
    'Cs':[25, 3, 0.81],
    'Ba':[25, 3, 1.84],
    'La':[25, 3, 4.42],
    'Ce':[25, 3, 4.23],
    'Pr':[25, 3, 3.71],
    'Nd':[25, 3, 3.28],
    'Pm':[25, 3, 2],
    'Sm':[25, 3, 2.16],
    'Eu':[25, 3, 1.85],
    'Gd':[25, 3, 3.57],
    'Tb':[25, 3, 3.81],
    'Dy':[25, 3, 2.89],
    'Ho':[25, 3, 3.05],
    'Er':[25, 3, 3.05],
    'Tm':[25, 3, 2.52],
    'Yb':[25, 3, 1.74],
    'Lu':[25, 3, 4.29],
    'Hf':[25, 3, 6.31],
    'Ta':[25, 3, 8.1],
    'W':[25, 3, 8.68],
    'Re':[25, 3, 8.09],
    'Os':[25, 3, 8.13],
    'Ir':[25, 3, 6.9],
    'Pt':[25, 3, 5.86],
    'Au':[25, 3, 3.8],
    'Hg':[25, 3, 0.64],
    'Tl':[25, 3, 1.88],
    'Pb':[25, 3, 2.03],
    'Bi':[25, 3, 2.17],
    'Po':[25, 3, 1.5],
    'At':[25, 3, 2],
    'Rn':[25, 3, 2],
    'Fr':[25, 3, 2],
    'Ra':[25, 3, 2],
    'Ac':[25, 3, 2],
    'Th':[25, 3, 5.93],
    'Pa':[25, 3, 2],
    'U':[25, 3, 5.42]
}

if __name__ == '__main__':
    import sys
    sys.path.append('../..') # to start dummy_tin.xxx
    import dummy_tin.physics.element as e

    for i, s in enumerate(e.table_bynum):
        print(i, s.sym, disp.get(s.sym, default))


